-- Time profile based on 1506 samples.
-- Left margin shows the percentage of total execution time
-- consumed by the statement(s) on that line.

       |without type_check -- makes no difference
       |
       |constant BATCH = 50
       |constant BENCH_TIME = 15
       |
       |constant SIZE = 500  -- finds primes up to SIZE*2+1
       |		     -- (only tests odd numbers)
       |constant ON = 1, OFF = 0
       |constant SCREEN = 1
       |
       |sequence flags 
       |
       |function sieve()
       |    integer prime, start, count, still_prime
       |
       |    count = 0
  4.12 |    flags = repeat(ON, SIZE)
  0.33 |    for i = 1 to SIZE do
 11.02 |	still_prime = flags[i]
  8.70 |	if still_prime then
  2.52 |	    prime = 2 * i 
  1.93 |	    prime += 1 
  5.51 |	    start = prime + i
 13.75 |	    for k = start to SIZE by prime do
 20.12 |		flags[k] = OFF
 19.12 |	    end for 
  1.20 |	    count += 1
       |	end if
 10.62 |    end for
  0.40 |    return count
       |end function
       |
       |atom t, cycles
       |
       |puts(SCREEN, "prime sieve benchmark ...\n")
       |cycles = 0
       |t = time()
       |while time() < t + BENCH_TIME do
       |    for iter = 1 to BATCH do
  0.20 |	if sieve() != 167 then
       |	    puts(SCREEN, "whoops!\n")
       |	end if
  0.13 |    end for
       |    cycles = cycles + BATCH
       |end while
       |t = time() - t
  0.07 |printf(SCREEN, "%6.1f sieves per second\n", cycles / t)
       |
       |-- display results
       |puts(SCREEN, "   2") -- 2 is also a prime
       |for i = 1 to SIZE do
       |    if flags[i] then
  0.27 |	printf(SCREEN, " %3d", i*2+1)
       |    end if
       |end for
       |

